//+----------------------------------------------------------------+
//|                                                BB_%.mq4        |
//|                                   Modified by GGG_Trading      |
//|                     http://donneeseconomiques.wordpress.com/   |
//+----------------------------------------------------------------+
#property copyright "Copyright ? 2008, Walter Choy"
#property link      ""
#property strict

#property indicator_separate_window
#property indicator_buffers  6
#property indicator_color1   clrRed
#property indicator_color2   clrYellow // Pink // Red
#property indicator_color3   clrSilver
#property indicator_color4   clrSilver
#property indicator_color5   clrLime//Red
#property indicator_color6   clrPink // Red

#property indicator_width5 1
#property indicator_width6 1

#property indicator_style3 2
#property indicator_style4 2

#property  indicator_levelstyle 2 
#property  indicator_levelcolor clrYellow

//#property indicator_minimum -5 
//#property indicator_maximum 105 

extern int    Bands_period = 20;
extern double Bands_deviation = 2;
extern int    smoothing = 3; 
extern bool   Level_or_BB = false;
extern int    Bands_period_2 = 77;
extern double Bands_deviation_2 = 1.5;
extern double upper_level = 90;
extern double lower_level = 10;
extern int    History = 5000;
//---- buffers
double PercentBB[];
double BB_Smooth[];
double Fleche_up_1[];
double Fleche_down_1[];
double BBUp[];
double BBDn[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle (0, DRAW_LINE);
   SetIndexBuffer(0, PercentBB);
   SetIndexLabel (0, "%BB");
   SetIndexDrawBegin(0, Bands_period);
//----
   SetIndexStyle (1,  DRAW_LINE);
   SetIndexBuffer(1, BB_Smooth);
   SetIndexLabel (1, "%BB_Smooth");
   SetIndexDrawBegin(1, Bands_period);
//----
   SetIndexStyle (2, DRAW_LINE);
   SetIndexBuffer(2, BBUp);
   SetIndexLabel (2, "BB2Up");
   SetIndexDrawBegin(2, Bands_period);
//----
   SetIndexStyle (3,  DRAW_LINE);
   SetIndexBuffer(3, BBDn);
   SetIndexLabel (3, "BB2Dn");
   SetIndexDrawBegin(3, Bands_period);
//----   
   SetIndexBuffer(4, Fleche_up_1 );
   SetIndexStyle (4, DRAW_ARROW);
   SetIndexArrow (4,233);
   SetIndexEmptyValue(4,0.0);
//-----   
   SetIndexBuffer(5,Fleche_down_1);
   SetIndexStyle (5, DRAW_ARROW);
   SetIndexArrow (5,234);
   SetIndexEmptyValue(5,0.0);// 
//-----   
   if(Level_or_BB)
    {
      SetLevelValue( 0, 50.0 );
      SetLevelValue( 1,upper_level );
      SetLevelValue( 2,lower_level );
      //SetLevelStyle( 0,1, Yellow);
    }else{
      SetLevelValue( 0,-100);
      SetLevelValue( 1,-100);
      SetLevelValue( 2,-100);  
    }
   int MaxPer = MathMax(Bands_period,Bands_period_2); 
   MaxPer = MathMax(MaxPer,smoothing);
   
   if(History>Bars-MaxPer)  History = Bars-MaxPer-1;
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted(); 
   //int History = 5000;
//----
   double LB, UB;
   int i,limit;
   
   if(counted_bars > 0) counted_bars--;
   limit = Bars - counted_bars;
   if(limit > History) limit = History;
      
   for(i = 0; i < limit; i++)
    {
      LB = iBands(NULL, 0, Bands_period, Bands_deviation, 0, PRICE_CLOSE, MODE_LOWER, i);
      UB = iBands(NULL, 0, Bands_period, Bands_deviation, 0, PRICE_CLOSE, MODE_UPPER, i);
 
      PercentBB[i] =  ( Close[i+1] - LB)/(UB - LB) * 100;
    }
//---- signal line is simple movimg average
   for(i=0; i<limit; i++)
      BB_Smooth[i]=iMAOnArray(PercentBB,Bars,smoothing,0,MODE_SMA,i);
//---- signal line is simple movimg average
   if(Level_or_BB)
    {
      for(i=0; i<limit; i++)
       {
         if(BB_Smooth[i+1] > upper_level &&   BB_Smooth[i] < upper_level)
           Fleche_down_1[i] = upper_level; else Fleche_down_1[i] = 0;                      
               
         if(BB_Smooth[i+1] < lower_level &&   BB_Smooth[i] > lower_level)
           Fleche_up_1[i] = lower_level;   else Fleche_up_1[i] = 0;  
       }
    }else{
      for(i=0; i<limit; i++)
       {
         BBUp[i] = iBandsOnArray(BB_Smooth,0,Bands_period_2, Bands_deviation_2,0,MODE_UPPER,i);
         BBDn[i] = iBandsOnArray(BB_Smooth,0,Bands_period_2, Bands_deviation_2,0,MODE_LOWER,i);
       }
      for(i=0; i<limit; i++)
       { 
         if(BB_Smooth[i+1] > BBUp[i+1] && BB_Smooth[i] < BBUp[i]) 
           Fleche_down_1[i] = BBUp[i]+15; else Fleche_down_1[i] = 0;
        
         if(BB_Smooth[i+1] < BBDn[i+1] && BB_Smooth[i] > BBDn[i])
           Fleche_up_1[i] = BBDn[i]-15;   else Fleche_up_1[i] = 0; 
       }
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+


